﻿using System.Collections.Concurrent;
using System.Net;
using Tarpit;

const string filePath = "/home/skingging/Documents/Projects/CSharp/AI-Tarpit/Tarpit/words/wordlist.txt";
WordUtils utils = new();
Dictionary<string, List<string>> words = WordUtils.LoadData(filePath);

// TODO: Create a thread that continuously fills the queue, that can later be consumed by the server utils.
ConcurrentQueue<string> tags = new();
Thread createTags = new(() => TagUtils.CreateTags(tags, words));
createTags.Start();

const string baseAddress = "http://localhost:10000/";

while (true)
{
    HttpListener listener = new();
    listener.Prefixes.Add(baseAddress);
    listener.Start();
    
    while (true)
    {
        HttpListenerContext context = await listener.GetContextAsync();
        ServerUtils serverUtils = new();
        
        Thread thread = new(() => _ = serverUtils.Serve(context, tags));
        thread.Start();
        //await serverUtils.Serve(context);
    }
}